unit AcctBook1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls,
  Forms, Dialogs, Menus, ExtCtrls, StdCtrls,
  ComCtrls, FileCtrl, Grids, MyIsam;

type
  TForm1 = class(TForm)
    Isam1: TMyIsam;
    Msg: TPanel;
    Panel1: TPanel;
    Label14: TLabel;
    Acct: TEdit;
    btnDelete: TButton;
    btnFind: TButton;
    btnLast: TButton;
    btnUpdate: TButton;
    btnPrior: TButton;
    btnNext: TButton;
    btnFirst: TButton;
    Label1: TLabel;
    Label2: TLabel;
    Client: TEdit;
    Phone: TEdit;
    RecNo: TLabel;


    procedure GetRecord;
    procedure SetRecord;
    procedure FormCreate(Sender: TObject);
    procedure btnFirstClick(Sender: TObject);
    procedure btnNextClick(Sender: TObject);
    procedure btnPriorClick(Sender: TObject);
    procedure btnLastClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure btnDeleteClick(Sender: TObject);
    procedure btnFindClick(Sender: TObject);
    procedure btnUpdateClick(Sender: TObject);
  private
    Rec: string;
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
begin
  if Isam1.Open('AcctBook') then
     btnFirstClick(Sender);

  Msg.Caption := Isam1.ErrMsg;
end;

procedure TForm1.GetRecord;
begin
  Acct.Text    := Trim(Copy(Rec,1,5));
  Phone.Text   := Trim(Copy(Rec,7,10));
  Client.Text  := Trim(Copy(Rec,18,23));
  RecNo.Caption:= 'Rec# '+IntToStr(Isam1.CurRec);

  if Isam1.ErrNo <> ISERR_OK then
     Msg.Caption:='Error: '+Isam1.ErrMsg;
end;

procedure TForm1.SetRecord;
const
 BLANKS = '                        ';
begin
  Rec := Copy(Trim(Acct.Text)  + BLANKS, 1, 5)  + '|' +
         Copy(Trim(Phone.Text) + BLANKS, 1, 10) + '|' +
         Copy(Trim(Client.Text)+ BLANKS, 1, 23);
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Isam1.Close;
end;

procedure TForm1.btnFirstClick(Sender: TObject);
begin
  Msg.Caption := 'First Record';
  Isam1.Read(Rec, ISFIRST);
  GetRecord;
end;

procedure TForm1.btnNextClick(Sender: TObject);
begin
  Msg.Caption := 'Next Record';
  Isam1.Read(Rec, ISNEXT);
  GetRecord
end;

procedure TForm1.btnPriorClick(Sender: TObject);
begin
  Msg.Caption := 'Prior record';
  Isam1.Read(Rec, ISPRIOR);
  GetRecord
end;

procedure TForm1.btnLastClick(Sender: TObject);
begin
  Msg.Caption := 'Last record';
  Isam1.Read(Rec, ISLAST);
  GetRecord;
end;

procedure TForm1.btnFindClick(Sender: TObject);
begin
  Msg.Caption := 'Key found';
  SetRecord;
  Isam1.Read(Rec,ISKEY);
  GetRecord;
end;

procedure TForm1.btnUpdateClick(Sender: TObject);
begin
  SetRecord;

  if Isam1.Search(Acct.Text) then
     begin // if the key exists then update the record
      Msg.Caption := RecNo.Caption+' Changed.';
      Isam1.Write(Rec,ISUPDATE);
     end
  else
     begin // if the key does not exist then insert the record
      Msg.Caption := RecNo.Caption+' Added.';
      Isam1.Write(Rec,ISINSERT);
     end;

  GetRecord;
end;

procedure TForm1.btnDeleteClick(Sender: TObject);
begin
  Msg.Caption := RecNo.Caption+' deleted.';
  SetRecord;
  Isam1.Delete(Rec);
  GetRecord;
end;

end.
